
#include <cstring>
#include "stringbuilder.h"

int StringBuilder::counter = 0;

StringBuilder::StringBuilder()
{
	const char *defaultStr = "Default String";
	int len = std::strlen(defaultStr);
	str = new char[len + 1];
	std::strcpy(str,"Default String");
	counter++;
	std::cout <<"Default Constructor counter=" << counter << std::endl;
}

StringBuilder::StringBuilder(const char *s)
{
	int len = std::strlen(s);
	str = new char[len + 1];
	std::strcpy(str,s);
	counter++;
	std::cout <<"Constructor counter=" << counter << std::endl;
}

StringBuilder::~StringBuilder()
{
	counter--;
	std::cout <<"Destructor counter=" << counter << std::endl;
	delete [] str;
}

/* Copy Constructor doing Deep Copy */
StringBuilder::StringBuilder(const StringBuilder & s)
{
	int len = std::strlen(s.str);
	str = new char[len + 1];
	std::strcpy(str,s.str);
	counter++;
	std::cout <<"Copy Constructor counter=" << counter << std::endl;
}


/* Copy Constructor doing Shallow Copy */
/*
StringBuilder::StringBuilder(const StringBuilder & s)
{
	str = s.str;
	counter++;
	std::cout <<"Copy Constructor counter=" << counter << std::endl;
}
*/

StringBuilder & StringBuilder::operator=(const StringBuilder & s)
{
	if(this == &s)
		return *this;
	delete [] str;
	int len = std::strlen(s.str);
	str = new char[len + 1];
	std::strcpy(str,s.str);
	return *this;
}

const char* StringBuilder::getString()
{
	return str;
}
